'---- Window Engine -----
'By Dennis Hotson (AKA Dj Dennie) 2002

'Drag/switch windows with your left mouse button
'Use the right mouse button to exit
'Note: REQUIRES FUTURE LIBRARY

'--------<   you can change these settings   >------------------'
                                                                '
CONST maxwin = 4            '  number of windows                '
CONST border = 5            '  width of window borders          '
CONST blend = 1             '  toggle blending                  '
CONST faderate = .4         '  rate of fading                   '
CONST activet = 250         '  transparency of active window    '
CONST inactivet = 100       '    "   "    of inactive window    '
CONST clickt = 20           '    "   "    of  dragged window    '
CONST ems = 1               '  toggle background image          '
CONST bgfile = "blue.bmp"   '  background file (BMP)            '

REM $INCLUDE: 'future.bi'

TYPE wind
        x AS INTEGER            'x position
        y AS INTEGER            'y position
        height AS INTEGER       'height of window
        width AS INTEGER        'width of window
        trans AS INTEGER        'transparency level
        msg AS STRING * 32      'window message
END TYPE

DECLARE SUB win (wind AS wind)
DECLARE SUB zbox (wind AS ANY, z AS INTEGER)
DECLARE FUNCTION rbox% (wind AS ANY, mx%, my%)

DIM wind(1 TO maxwin) AS wind  '---------< array of windows
DIM order(1 TO maxwin) AS INTEGER  '-----< required to order windows
DIM SHARED xres, yres

Set320x200 16
xres = 320
yres = 200

'----------------< init windows
RANDOMIZE TIMER
FOR i = 1 TO maxwin
        wind(i).x = INT(RND * 200)
        wind(i).y = INT(RND * 100)
        wind(i).height = 50 + INT(RND * 30)
        wind(i).width = INT(RND * 10) + 180
        'wind(i).trans = INT(RND * 10) + 150
        wind(i).msg = "WIN:" + STR$(i)
        order(i) = i
NEXT i
'------------------------------------------< default msg's
wind(4).msg = "Window Demo"
wind(3).msg = "By Dj Dennie"
wind(2).msg = "2002"
wind(1).msg = "Right click to exit"


Future.LoadFONT "hylas.fnt"
IF ems = 1 THEN
        '-----------< load background image
        handle% = AllExpMem(SizeOf(xres, yres))
        DefineEMSbufferSize handle%, xres, yres, 0
        SetEMSpage 0
        future.cls 0
        Future.Loadbmp bgfile, 0, 0
'-----------<
END IF

page% = Pages%  '-------< find num of pages available

DO
        Future.UpdateMouse
        mx = Future.MouseX         '------< mouse stuff
        my = Future.MouseY
        mb = Future.MouseB

        
        setpage page%
        IF blend = 1 THEN setblender 0


        future.cls (0)
        FOR i = 1 TO maxwin
                a = order(i)
                zbox wind(a), a            '---------< draw z windows
        NEXT i
        z = Future.POINT(mx, my)
        
        '----------< window click
        IF (mb AND 1) = 1 AND click = 1 AND z > 0 THEN
                FOR i = 1 TO maxwin - 1
                        IF order(i) = z THEN SWAP order(i), order(maxwin)
                NEXT i
                click = 2
        END IF



        '------< window dragging
        IF (mb AND 1) = 1 AND rbox(wind(order(maxwin)), mx, my) = 1 THEN

                wind(order(maxwin)).x = mx - wind(order(maxwin)).width / 2
                wind(order(maxwin)).y = my - wind(order(maxwin)).height / 2
                FOR i = 1 TO maxwin - 1
                        dt = wind(order(i)).trans - inactivet
                        wind(order(i)).trans = wind(order(i)).trans - faderate * dt
                NEXT i
                dt = wind(order(maxwin)).trans - clickt
                wind(order(maxwin)).trans = wind(order(maxwin)).trans - faderate * dt

        END IF


        '------< idle
        IF mb = 0 THEN
                FOR i = 1 TO maxwin - 1
                        dt = wind(order(i)).trans - inactivet
                        wind(order(i)).trans = wind(order(i)).trans - faderate * dt
                NEXT i
                dt = wind(order(maxwin)).trans - activet
                wind(order(maxwin)).trans = wind(order(maxwin)).trans - faderate * dt


                click = 1
        END IF

        p = (p + 1) MOD page%
        setpage (p)

        future.cls RGB2Color(69, 94, 195)
        IF ems = 1 THEN future.emsput 0, 0, handle%           '-------< draw background

        FOR i = 1 TO maxwin
                a = order(i)
                win wind(a)             '---------< draw windows
        NEXT i

        'IF z > 0 THEN future.print 1, 1, STR$(order(z)), RGB2Color(255, 255, 255), -1
        ViewPage p



        IF flag = 0 THEN
                future.mouseon
                flag = 1
        END IF


LOOP UNTIL (mb AND 2) = 2

'DeallExpMem handle%
ReSetScreen
CLEAR
SYSTEM

FUNCTION rbox (wind AS wind, mx AS INTEGER, my AS INTEGER)
'------< checks if cursor is in range  1 = true 0 = false

rbox = 0
IF mx >= wind.x AND mx <= (wind.x + wind.width) AND my >= wind.y AND my <= (wind.y + wind.height) THEN rbox = 1
END FUNCTION

SUB win (wind AS wind)
'--------< draw a window



IF blend = 1 THEN setblender wind.trans

'--------< draw outer border
future.fillbox wind.x, wind.y, (wind.width + wind.x), (wind.height + wind.y), RGB2Color(221, 221, 221)
Future.BOX wind.x, wind.y, (wind.width + wind.x), (wind.height + wind.y), RGB2Color(0, 0, 0)

future.line wind.x + 1, wind.y + 1, (wind.width + wind.x) - 1, wind.y + 1, RGB2Color(255, 255, 255), -1
future.line wind.x + 1, wind.y + 1, wind.x + 1, (wind.height + wind.y) - 1, RGB2Color(255, 255, 255), -1

future.line (wind.width + wind.x) - 1, wind.y + 1, (wind.width + wind.x) - 1, (wind.height + wind.y) - 1, RGB2Color(170, 170, 170), -1
future.line wind.x + 1, (wind.height + wind.y) - 1, (wind.width + wind.x) - 1, (wind.height + wind.y) - 1, RGB2Color(170, 170, 170), -1

future.pset (wind.width + wind.x) - 1, wind.y + 1, RGB2Color(255, 255, 255)
future.pset wind.x + 1, (wind.height + wind.y) - 1, RGB2Color(255, 255, 255)


'---------< draw inner part
future.fillbox wind.x + border, wind.y + border, (wind.width + wind.x) - border, (wind.height + wind.y) - border, RGB2Color(255, 255, 255)
Future.BOX wind.x + border, wind.y + border, (wind.width + wind.x) - (border + 1), (wind.height + wind.y) - border, RGB2Color(0, 0, 0)

future.line wind.x + (border - 1), wind.y + border, wind.x + (border - 1), (wind.height + wind.y) - border, RGB2Color(170, 170, 170), -1
future.line wind.x + (border - 1), wind.y + (border - 1), (wind.width + wind.x) - (border + 1), wind.y + (border - 1), RGB2Color(170, 170, 170), -1

future.line wind.x + border, (wind.height + wind.y) - (border - 1), (wind.width + wind.x) - border, (wind.height + wind.y) - (border - 1), RGB2Color(255, 255, 255), -1
future.line (wind.width + wind.x) - border, (wind.height + wind.y) - (border - 1), (wind.width + wind.x) - border, wind.y + border, RGB2Color(255, 255, 255), -1

'set clipping viewport
SetViewPort wind.x + (border + 1), wind.y + (border + 1), (wind.width + wind.x) - (border + 1), (wind.height + wind.y) - (border + 1)
IF wind.x <= 0 THEN SetViewPort 0, wind.y + (border + 1), (wind.width + wind.x) - (border + 1), (wind.height + wind.y) - (border + 1)
IF wind.y <= 0 THEN SetViewPort wind.x + (border + 1), 0, (wind.width + wind.x) - (border + 1), (wind.height + wind.y) - (border + 1)
IF wind.x < 0 AND wind.y < 0 THEN SetViewPort 0, 0, (wind.width + wind.x) - (border + 1), (wind.height + wind.y) - (border + 1)



'------------< insert window contents here
'note: try to keep coords relative to wind.x and wind.y
future.print wind.x + border + 5, wind.y + border + 5, wind.msg, RGB2Color(0, 0, 0), -1



'future.line 0, 0, xres, yres, 0, -1   '----< used to test clipping viewport
'------------<
SetViewPort 0, 0, xres, yres

END SUB

SUB zbox (wind AS wind, z AS INTEGER)
'----< draw boxes depending on z level

future.fillbox wind.x, wind.y, (wind.width + wind.x), (wind.height + wind.y), z
END SUB

